package com.java2s.common;

import java.util.Collection;
import java.util.Date;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.springframework.transaction.annotation.Transactional;

@Transactional
public class PersonDaoImpl {
  public void test() {
    Employee emp = new Employee();
    emp.setName("Tom");
    emp.setSalary(123);
    emp.setStartDate(new Date());
    emp.setId(1);

    Project pro = new Project();
    pro.setName("Design");
    pro.getEmployees().add(emp);

    Department dept = new Department();
    dept.setName("Dept");
    dept.getEmployees().add(emp);

    emp.setDepartment(dept);
    emp.getProjects().add(pro);

    em.persist(dept);
    em.persist(pro);
    em.persist(emp);

    String deptName = "Dept";
    String empName = "Tom";

    List l = em.createQuery("SELECT e " +
            "FROM Project p JOIN p.employees e " +
            "WHERE p.name = :project " +
            "ORDER BY e.name")
            .setParameter("project", "Design")
            .getResultList();


     System.out.println(l);

  }
  public Collection<Employee> findAllEmployees() {
      return (Collection<Employee>) em.createQuery(
              "SELECT e FROM Employee e").getResultList();
  }
  @PersistenceContext
  private EntityManager em;
}
